/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.unis.basic.info.modular.orgInfo.service.impl;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.unis.basic.info.modular.orgInfo.mapper.OrgInfoMapper;
import com.unis.basic.info.modular.orgInfo.service.OrgInfoService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.unis.common.enums.CommonSortOrderEnum;
import com.unis.common.exception.CommonException;
import com.unis.common.page.CommonPageRequest;

import com.unis.basic.info.modular.orgInfo.entity.OrgInfo;
import com.unis.basic.info.modular.orgInfo.param.OrgInfoPageParam;
import com.unis.basic.info.modular.orgInfo.param.OrgInfoAddParam;
import com.unis.basic.info.modular.orgInfo.param.OrgInfoEditParam;
import com.unis.basic.info.modular.orgInfo.param.OrgInfoIdParam;


import java.util.List;

/**
 * 组织机构信息表Service接口实现类
 *
 * @author shine
 * @date  2024/04/28 11:47
 **/
@Service
public class OrgInfoServiceImpl extends ServiceImpl<OrgInfoMapper, OrgInfo> implements OrgInfoService {

    @Override
    public Page<OrgInfo> page(OrgInfoPageParam orgInfoPageParam) {
        QueryWrapper<OrgInfo> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isNotEmpty(orgInfoPageParam.getOrgName())) {
            queryWrapper.lambda().like(OrgInfo::getOrgName, orgInfoPageParam.getOrgName());
        }
        if(ObjectUtil.isNotEmpty(orgInfoPageParam.getUnitInfoId())) {
            queryWrapper.lambda().eq(OrgInfo::getUnitInfoId, orgInfoPageParam.getUnitInfoId());
        }
        if(ObjectUtil.isAllNotEmpty(orgInfoPageParam.getSortField(), orgInfoPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(orgInfoPageParam.getSortOrder());
            queryWrapper.orderBy(true, orgInfoPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(orgInfoPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(OrgInfo::getOrgId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(OrgInfoAddParam orgInfoAddParam) {
        OrgInfo orgInfo = BeanUtil.toBean(orgInfoAddParam, OrgInfo.class);
        this.save(orgInfo);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(OrgInfoEditParam orgInfoEditParam) {
        OrgInfo orgInfo = this.queryEntity(orgInfoEditParam.getOrgId());
        BeanUtil.copyProperties(orgInfoEditParam, orgInfo);
        this.updateById(orgInfo);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<OrgInfoIdParam> orgInfoIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(orgInfoIdParamList, OrgInfoIdParam::getOrgId));
    }

    @Override
    public OrgInfo detail(OrgInfoIdParam orgInfoIdParam) {
        return this.queryEntity(orgInfoIdParam.getOrgId());
    }

    @Override
    public OrgInfo queryEntity(Integer id) {
        OrgInfo orgInfo = this.getById(id);
        if(ObjectUtil.isEmpty(orgInfo)) {
            throw new CommonException("组织机构信息表不存在，id值为：{}", id);
        }
        return orgInfo;
    }
}
